//
//  SubdivisionsGreece.swift
//  
//
//  Created by Evan Anderson on 7/26/22.
//

import Foundation

public enum SubdivisionsGreece : String, CaseIterable, SovereignStateSubdivision { // https://en.wikipedia.org/wiki/Administrative_regions_of_Greece
    case attica
    case central_greece
    case central_macedonia
    case crete
    case eastern_macedonia_and_thrace
    case epirus
    case ionian_islands
    case mount_athos
    case north_aegean
    case peloponnese
    case south_aegean
    case thessaly
    case western_greece
    case western_macedonia
    
    public func getCountry() -> Country {
        return Country.greece
    }
    
    public func getType() -> SovereignStateSubdivisionType {
        return SovereignStateSubdivisionType.regions
    }
    
    public func getWikipediaURLSuffix() -> String? {
        switch self {
        case .central_macedonia,
                .crete,
                .eastern_macedonia_and_thrace,
                .mount_athos,
                .north_aegean,
                .south_aegean,
                .thessaly,
                .western_greece,
                .western_macedonia:
            return nil
        default:
            return "_(region)"
        }
    }
}
